/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2022. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
/**
 * Interface for various job APIs
 * @export
 * @interface ICommonJobParms
 */
export interface ICommonJobParms {
    /**
     * job id for a job
     * @type {string}
     * @memberof ICommonJobParms
     */
    jobId: string;
    /**
     * job name for a job
     * @type {string}
     * @memberof ICommonJobParms
     */
    jobName: string;
}
