/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2022. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
"use strict";var __createBinding=this&&this.__createBinding||(Object.create?function(e,t,i,r){void 0===r&&(r=i),Object.defineProperty(e,r,{enumerable:!0,get:function(){return t[i]}})}:function(e,t,i,r){void 0===r&&(r=i),e[r]=t[i]}),__setModuleDefault=this&&this.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),__importStar=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var i in e)"default"!==i&&Object.prototype.hasOwnProperty.call(e,i)&&__createBinding(t,e,i);return __setModuleDefault(t,e),t},__awaiter=this&&this.__awaiter||function(e,t,i,r){return new(i||(i=Promise))((function(n,s){function a(e){try{u(r.next(e))}catch(e){s(e)}}function o(e){try{u(r.throw(e))}catch(e){s(e)}}function u(e){var t;e.done?n(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(a,o)}u((r=r.apply(e,t||[])).next())}))},__importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.SchemaDocumentInstance=void 0;const fs=__importStar(require("fs")),cjs_1=__importDefault(require("yawn-yaml/cjs"));class SchemaDocumentInstance{constructor(e,t){this.isValid=!1,t&&this.prependErrorMessage(t);try{this.yawn=new cjs_1.default(e),this.validate()}catch(e){this.prependErrorMessage(null==e?void 0:e.message)}}getAsYaml(){var e;return null===(e=this.yawn)||void 0===e?void 0:e.yaml}getAsJson(){var e;return JSON.stringify(null===(e=this.yawn)||void 0===e?void 0:e.json)}getAsObject(){var e;return null===(e=this.yawn)||void 0===e?void 0:e.json}static readFileWithRetry(e){return __awaiter(this,void 0,void 0,(function*(){let t="";for(let i=0;i<10;i++){if(t=yield fs.promises.readFile(e,"utf8"),t)return t;yield new Promise((e=>setTimeout(e,100)))}return t}))}write(){var e,t;if(this.isValid){if(null===(t=this.file)||void 0===t?void 0:t.path){let e="# Undefined "+this.type+" document.";"json"===this.file.type&&(e=JSON.stringify(this.getAsObject())),"yaml"===this.file.type&&(e=this.getAsYaml()||e),fs.writeFileSync(this.file.path,e,{encoding:"utf-8"})}}else this.appendErrorMessage(`Tried to write invalid document "${null===(e=this.file)||void 0===e?void 0:e.path}"`)}appendErrorMessage(e){const t=this.errorMessages?`${this.errorMessages}\n`:"";this.errorMessages=`${t}- ${e||"Unknown Error reading "+this.type+" file."}`}prependErrorMessage(e){const t=this.errorMessages?`\n${this.errorMessages}`:"";this.errorMessages=`- ${e||"Unknown Error reading "+this.type+" file."}${t}`}}exports.SchemaDocumentInstance=SchemaDocumentInstance;