/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2022. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
"use strict";var __createBinding=this&&this.__createBinding||(Object.create?function(e,t,a,s){void 0===s&&(s=a),Object.defineProperty(e,s,{enumerable:!0,get:function(){return t[a]}})}:function(e,t,a,s){void 0===s&&(s=a),e[s]=t[a]}),__setModuleDefault=this&&this.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),__importStar=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var a in e)"default"!==a&&Object.prototype.hasOwnProperty.call(e,a)&&__createBinding(t,e,a);return __setModuleDefault(t,e),t};Object.defineProperty(exports,"__esModule",{value:!0}),exports.SchemaDocumentCache=void 0;const path=__importStar(require("path")),os=__importStar(require("os")),zapp_document_instance_1=require("../../zapp/parser/zapp-document-instance"),zcodeformat_document_instance_1=require("../../zcodeformat/parser/zcodeformat-document-instance");class SchemaDocumentCache{constructor(e){this.type=e,this.documentsCache=new Map,this.workspacesMap=new Map,this.numberDocsAdded=0,this.numberDocsRemoved=0,this.numberDocsFound=0}addDocument(e,t,a){this.documentsCache.set(e,a),this.workspacesMap.set(t,e)}clearSchemaDocument(e){if(!e)return;const t=this.normalizePath(e),a=path.dirname(t);this.workspacesMap.has(a)&&this.workspacesMap.delete(a),this.documentsCache.has(t)&&(this.documentsCache.delete(t),this.numberDocsRemoved++)}clearCache(){this.workspacesMap.clear(),this.documentsCache.clear()}getCacheStats(){return{documentsCacheSize:this.documentsCache.size,workspacesMapSize:this.workspacesMap.size,numberDocsAdded:this.numberDocsAdded,numberDocsRemoved:this.numberDocsRemoved,numberDocsFound:this.numberDocsFound}}normalizePath(e){if(!e||!path.isAbsolute(e))return e;let t=path.normalize(e);if("win32"===os.platform()){const e=path.basename(t);let a;if(a="zapp"==this.type?zapp_document_instance_1.ZappDocumentInstance.isZappFileName(e):"zcodeformat"==this.type&&zcodeformat_document_instance_1.ZCodeFormatDocumentInstance.isZCodeFormatFileName(e),a){const a=path.dirname(t);t=path.join(a.toUpperCase(),e)}else t=t.toUpperCase()}return t}}exports.SchemaDocumentCache=SchemaDocumentCache;