/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2022. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
import { Session, IHandlerParameters } from '@zowe/imperative';
import { RestBaseHandler } from '../../../RestBaseHandler';
import { IRestApiResponse } from '../../../../api/doc/IRestApiResponse';
/**
 * Handler for the "zos-jobs list jobs" command.
 * @export
 * @class JobsHandler
 * @implements {ICommandHandler}
 */
export default class JobsHandler extends RestBaseHandler {
    processWithSession(params: IHandlerParameters, session: Session): Promise<IRestApiResponse>;
}
