/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2022. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
import { IUploadOptions } from '@zowe/cli';
export interface IUploadRseOptions extends Omit<IUploadOptions, 'encoding'> {
    /**
     * Code page encoding
     * @type {string | number}
     */
    encoding?: string | number;
}
