/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2022. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
"use strict";var __awaiter=this&&this.__awaiter||function(t,e,n,a){return new(n||(n=Promise))((function(c,s){function i(t){try{h(a.next(t))}catch(t){s(t)}}function o(t){try{h(a.throw(t))}catch(t){s(t)}}function h(t){var e;t.done?c(t.value):(e=t.value,e instanceof n?e:new n((function(t){t(e)}))).then(i,o)}h((a=a.apply(t,e||[])).next())}))};Object.defineProperty(exports,"__esModule",{value:!0}),exports.ZappDocumentsCache=void 0;const zapp_document_instance_1=require("./zapp-document-instance"),schema_documents_cache_1=require("../../schemas/parser/schema-documents-cache");class ZappDocumentsCache extends schema_documents_cache_1.SchemaDocumentCache{static getInstance(){return this.instance||(this.instance=new ZappDocumentsCache(this.cacheType)),this.instance}static resetInstance(){this.instance=void 0}static getZappDocument(t){if(!t)return;const e=this.getInstance().normalizePath(t);return this.getInstance().documentsCache.has(e)?(this.getInstance().numberDocsFound++,this.getInstance().documentsCache.get(e)):void 0}static loadZappDocument(t,e){return __awaiter(this,void 0,void 0,(function*(){if(!t)return;const n=this.getInstance().normalizePath(t);if(this.getInstance().documentsCache.has(n))return this.getInstance().numberDocsFound++,this.getInstance().documentsCache.get(n);const a=yield zapp_document_instance_1.ZappDocumentInstance.createFromFile(n);return this.getInstance().addDocument(t,e,a),this.getInstance().numberDocsAdded++,a}))}static clearZappDocument(t){this.getInstance().clearSchemaDocument(t)}static getZappDocumentInWorkspace(t){if(!t)return;const e=this.getInstance().normalizePath(t),n=this.getInstance().workspacesMap.get(e);return n?this.getZappDocument(n):void 0}static loadZappDocumentInWorkspace(t){return __awaiter(this,void 0,void 0,(function*(){const e=this.getInstance().normalizePath(t),n=zapp_document_instance_1.ZappDocumentInstance.findZappFile(e);if(n){const a=yield this.loadZappDocument(n.path,t);return this.getInstance().workspacesMap.set(e,n.path),a}}))}static getCacheStats(){return this.getInstance().getCacheStats()}static clearCache(){this.getInstance().clearCache(),this.resetInstance()}}exports.ZappDocumentsCache=ZappDocumentsCache,ZappDocumentsCache.cacheType="zapp";