/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2022. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.UssFileDefinition=void 0;const Download_options_1=require("../../Download.options"),strings=require("../../../-strings-/en").default.DOWNLOAD.ACTIONS.USS_FILE;exports.UssFileDefinition={name:"uss-file",aliases:["uf"],summary:strings.SUMMARY,description:strings.DESCRIPTION,type:"command",handler:__dirname+"/UssFile.handler",profile:{optional:["rse"]},positionals:[{name:"ussFileName",description:strings.POSITIONALS.USSFILENAME,type:"string",required:!0}],options:[Download_options_1.DownloadOptions.file,Download_options_1.DownloadOptions.binary,Download_options_1.DownloadOptions.encoding].sort(((o,s)=>o.name.localeCompare(s.name))),examples:[{description:strings.EXAMPLES.EX1,options:'"/a/ibmuser/my_text.txt" -f "./my_text.txt"'},{description:strings.EXAMPLES.EX2,options:'"/a/ibmuser/my_text.txt" -b -f "./my_text.txt"'}]};