/*
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2020, 2022. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *
 */
import { Session, IHandlerParameters } from '@zowe/imperative';
import { IRestApiResponse } from '../../../api/doc/IRestApiResponse';
import { RestBaseHandler } from '../../RestBaseHandler';
/**
 * Handler to upload content from a local directory to a USS directory
 * @export
 */
export default class DirToUSSDirHandler extends RestBaseHandler {
    processWithSession(commandParameters: IHandlerParameters, session: Session): Promise<IRestApiResponse>;
    private findAttributesFile;
    private uploadWithAttributesFile;
    private buildFilesMap;
}
